<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="pageTitle">
      <el-row>
        <div class="el-row-button-input">
          <label>
            {{ $t('nav.resourcelist') }}
          </label>
          <label
            v-if="addResource"
            style="color:gray"
          >
            / Add Resource
          </label>
          <label
            v-if="isApplication"
            style="color:gray"
          >
            / Add Environment
          </label>
          <el-button
            v-if="isResources && !isApplication && !isLab && !addResource"
            id="batchDltBtn"
            style="float:right;"
            type="primary"
            @click="resDialogVisible = true; addResource = true; currentRowData = {}"
          >
            <em class="el-icon-document-copy" />
            {{ $t('env.addres') }}
          </el-button>
          <el-button
            v-if="!isApplication && !isResources && !isLab"
            id="batchDltBtn"
            style="float:right;"
            type="primary"
            @click="isApplication = true"
          >
            <em class="el-icon-document-copy" />
            {{ $t('env.addenv') }}
          </el-button>
          <el-button
            id="backEnvBtn"
            style="float:right;"
            type="primary"
            v-if="(isApplication || addResource) && !isLab"
            @click="isApplication = false; addResource = false; resDialogVisible = false"
          >
            <em class="el-icon-back" />
            Back
          </el-button>
          <el-button
            id="backEnvBtn"
            style="float:right;"
            type="primary"
            v-if="isLab"
            @click="labDialogVisible = true; fileList = []"
          >
            {{ $t('env.addlab') }}
          </el-button>
        </div>
      </el-row>
    </div>
    <div
      class="userList"
      v-if="isApplication"
    >
      <AddEnvironment
        @cancelDialog="cancel"
        :current-data="currentRowData"
      />
    </div>
    <div
      class="userList"
      v-if="resDialogVisible"
    >
      <AddResource
        @cancelDialog="cancel"
        :current-data="currentRowData"
      />
    </div>
    <div
      class="userList"
      v-if="!resDialogVisible && !isApplication"
    >
      <el-row>
        <el-col :span="8">
          <DoNut
            :chart-id="'envchart'"
            :name="$t('common.environments')"
            :graph-data="envGraphData"
            :label-pos="180"
            :graph-color="['#327ace', '#3fa981']"
            :legend-name="['Available', 'Assigned']"
          />
        </el-col>
        <el-col :span="8">
          <DoNut
            :chart-id="'reschart'"
            name="Resource"
            :graph-color="['#327ace', '#3fa981']"
            :graph-data="resGraphData"
            :label-pos="200"
            :legend-name="['Available', 'Assigned']"
          />
        </el-col>
      </el-row>
      <el-tabs
        type="border-card"
        @tab-click="changeTabs"
        style="margin-top: 80px"
        v-model="selectedTab"
      >
        <el-tab-pane
          :label="$t('common.environments')"
          name="Environments"
        >
          <SearchResource
            :lab-item="true"
            :status-item="true"
            :status-options="['ALL', 'Available', 'Assigned']"
            @getSearchData="getEnvDataList"
          />
          <div class="tableDiv">
            <el-row>
              <el-col
                :span="24"
                class="table"
              >
                <el-table
                  v-loading="dataLoading"
                  :data="currPageEnvTableData"
                  border
                  @selection-change="handleSelectionChange"
                >
                  <el-table-column
                    prop="envName"
                    :label="$t('env.name')"
                  />
                  <el-table-column
                    prop="lab"
                    :label="$t('env.lab')"
                  />
                  <el-table-column
                    :label="$t('env.status')"
                  >
                    <template slot-scope="scope">
                      <span
                        :style="getStatusColor(scope.row.status)"
                      >
                        {{ $t(scope.row.status) }}
                      </span>
                    </template>
                  </el-table-column>
                  <el-table-column
                    prop="type"
                    :label="$t('env.type')"
                  />
                  <el-table-column
                    prop="duration"
                    :label="$t('env.duration')"
                  />
                  <el-table-column
                    prop="assignedTo"
                    :label="$t('env.assignedTo')"
                  />
                  <el-table-column
                    prop="remarks"
                    :label="$t('env.remark')"
                  />
                  <el-table-column
                    :label="$t('common.operation')"
                    width="150"
                  >
                    <template slot-scope="scope">
                      <el-button
                        id="editUsrBtn"
                        @click="getDetails(scope.row)"
                        type="text"
                        size="small"
                      >
                        {{ $t('env.details') }}
                      </el-button>
                      <el-button
                        id="editUsrBtn"
                        @click="deleteEnvironment(scope.row)"
                        type="text"
                        size="small"
                      >
                        {{ $t('common.delete') }}
                      </el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
            </el-row>
            <div class="pageBar">
              <Pagination
                :table-data="paginationEnvData"
                @getCurrentPageData="getCurrentEnvPageData"
              />
            </div>
          </div>
        </el-tab-pane>
        <el-tab-pane
          :label="$t('common.resources')"
          name="Resources"
        >
          <SearchResource
            :name-item="false"
            :ip-item="true"
            :lab-item="true"
            :status-item="true"
            :applicant-item="true"
            :status-options="['ALL', 'Available', 'Assigned']"
            @getSearchData="getResDataList"
          />
          <div class="tableDiv">
            <el-row>
              <el-col
                :span="24"
                class="table"
              >
                <el-table
                  v-loading="dataLoading"
                  :data="currPageResTableData"
                  border
                  @selection-change="handleSelectionChange"
                >
                  <el-table-column
                    prop="ipAddress"
                    :label="$t('env.ipAddress')"
                  />
                  <el-table-column
                    prop="lab"
                    :label="$t('env.lab')"
                  />
                  <el-table-column
                    :label="$t('env.status')"
                  >
                    <template slot-scope="scope">
                      <span
                        :style="getStatusColor(scope.row.status)"
                      >
                        {{ $t(scope.row.status) }}
                      </span>
                    </template>
                  </el-table-column>
                  <el-table-column
                    prop="architacture"
                    :label="$t('env.cpuArchitacture')"
                  />
                  <el-table-column
                    prop="specifications"
                    :label="$t('env.specifications')"
                  />
                  <el-table-column
                    prop="requestedBy"
                    :label="$t('env.applicant')"
                  />
                  <el-table-column
                    prop="specialResources"
                    :label="$t('env.specialResources')"
                  />
                  <el-table-column
                    prop="nodeType"
                    :label="$t('env.nodeType')"
                  />
                  <el-table-column
                    prop="remarks"
                    :label="$t('env.remark')"
                  />
                  <el-table-column
                    :label="$t('common.operation')"
                  >
                    <template slot-scope="scope">
                      <!-- <el-button
                        id="editUsrBtn"
                        @click="modifyResource(scope.row)"
                        type="primary"
                        size="small"
                      >
                        Application
                      </el-button> -->
                      <div style="text-align: center">
                        <span
                          class="el-icon-delete"
                          style="color: red; cursor:pointer"
                          @click="deleteResource(scope.row)"
                        />
                      </div>
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
            </el-row>
            <div class="pageBar">
              <Pagination
                :table-data="paginationResData"
                @getCurrentPageData="getCurrentResPageData"
              />
            </div>
          </div>
        </el-tab-pane>
        <el-tab-pane
          :label="$t('common.labs')"
          name="Lab"
        >
          <div class="tableDiv">
            <el-row>
              <el-col
                :span="24"
                class="table"
              >
                <el-table
                  v-loading="dataLoading"
                  :data="currPageLabTableData"
                  border
                >
                  <el-table-column
                    prop="labName"
                    :label="$t('env.name')"
                  />
                  <el-table-column
                    prop="owner"
                    :label="$t('env.owner')"
                  />
                  <el-table-column
                    prop="description"
                    :label="$t('env.description')"
                  />
                  <el-table-column
                    prop="address"
                    :label="$t('env.address')"
                  />
                  <el-table-column
                    prop="city"
                    :label="$t('env.city')"
                  />
                  <el-table-column
                    prop="pinCode"
                    :label="$t('env.pinCode')"
                  />
                  <el-table-column
                    :label="$t('common.operation')"
                    width="100"
                  >
                    <template slot-scope="scope">
                      <div style="text-align: center">
                        <span
                          class="el-icon-delete"
                          style="color: red; cursor:pointer"
                          @click="deleteLab(scope.row)"
                        />
                      </div>
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
            </el-row>
            <div class="pageBar">
              <Pagination
                :table-data="paginationLabData"
                @getCurrentPageData="getCurrentLabPageData"
              />
            </div>
          </div>
        </el-tab-pane>
      </el-tabs>
      <el-dialog
        :title="$t('env.addlab')"
        :visible.sync="labDialogVisible"
        v-loading="loading"
      >
        <el-form
          label-width="100px"
        >
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.name')"
            >
              <el-input
                type="text"
                v-model="currentRowData.labName"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.owner')"
            >
              <el-input
                type="text"
                v-model="currentRowData.owner"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              label="Contact"
            >
              <el-input
                type="text"
                v-model="currentRowData.contact"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.description')"
            >
              <el-input
                type="text"
                v-model="currentRowData.description"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.address')"
            >
              <el-input
                type="text"
                v-model="currentRowData.address"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.city')"
            >
              <el-input
                type="text"
                v-model="currentRowData.city"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              :label="$t('env.pinCode')"
            >
              <el-input
                type="text"
                v-model="currentRowData.pinCode"
              />
            </el-form-item>
          </div>
          <div style="margin-top: 15px;">
            <el-form-item
              label="Lab Image"
            >
              <input
                type="file"
                @change="addFile"
              >
            </el-form-item>
          </div>
        </el-form>
        <div
          slot="footer"
          class="dialog-footer"
        >
          <el-button
            id="cancelBtn"
            @click="cancel()"
          >
            {{ $t('common.cancel') }}
          </el-button>
          <el-button
            id="confirmBtn"
            type="primary"
            @click="addLab"
            :loading="loading"
          >
            Add
          </el-button>
        </div>
      </el-dialog>
      <el-dialog
        title="Resource Details"
        :visible.sync="resourceDetailVisible"
      >
        <div class="tableDiv">
          <el-table
            :data="resourceDetails"
            border
          >
            <el-table-column
              type="index"
              :label="$t('env.no')"
              width="50"
            />
            <el-table-column
              prop="lab"
              :label="$t('env.lab')"
            />
            <el-table-column
              prop="ipAddress"
              :label="$t('env.ipAddress')"
            />
            <el-table-column
              prop="nodeType"
              :label="$t('env.nodeType')"
            />
            <el-table-column
              prop="architacture"
              :label="$t('env.architacture')"
            />
            <el-table-column
              prop="specifications"
              :label="$t('env.specifications')"
            />
            <el-table-column
              prop="specialResources"
              :label="$t('env.specialResources')"
            />
          </el-table>
        </div>
        <div
          slot="footer"
          class="dialog-footer"
        >
          <el-button
            id="cancelBtn"
            @click="resourceDetailVisible = false"
          >
            {{ $t('common.cancel') }}
          </el-button>
        </div>
      </el-dialog>
    </div>
  </div>
</template>
<script>
import SearchResource from '../components/SearchResource.vue'
import Pagination from '../components/Pagination.vue'
import DoNut from './DoNut.vue'
import axios from 'axios'
import { BASE_URL } from '../tools/constant.js'
import AddEnvironment from './AddEnvironment.vue'
import AddResource from './AddResource.vue'
export default {
  name: 'ResourceList',
  components: {
    SearchResource,
    DoNut,
    AddEnvironment,
    AddResource,
    Pagination
  },
  data () {
    return {
      dataLoading: true,
      labDialogVisible: false,
      resDialogVisible: false,
      loading: false,
      dialogLoading: false,
      currentRowData: {},
      isResources: false,
      isApplication: false,
      addResource: false,
      envGraphData: [],
      resGraphData: [],
      labOptions: [],
      labDataList: [],
      isLab: false,
      resourceDetailVisible: false,
      resourceDetails: [],
      selectedTab: 'Environments',
      paginationEnvData: [],
      paginationResData: [],
      paginationLabData: [],
      currPageEnvTableData: [],
      currPageResTableData: [],
      currPageLabTableData: [],
      fileList: [],
      labData: new FormData()
    }
  },
  beforeMount () {
    this.getEnvDataList()
    this.getResDataList()
  },
  computed: {
  },
  methods: {
    handleChange (file, fileList) {
      this.fileList.push(file)
      if (this.fileList.length === 2) {
        this.fileList.pop()
      }
    },
    getCurrentEnvPageData (data) {
      this.currPageEnvTableData = data
    },
    getCurrentResPageData (data) {
      this.currPageResTableData = data
    },
    getCurrentLabPageData (data) {
      this.currPageLabTableData = data
    },
    getDetails (data) {
      let url = BASE_URL + '/getResourceDetails?envName=' + data.envName
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.resourceDetailVisible = true
        this.resourceDetails = res.data
      }, error => {
        if (error) {
          this.resourceDetailVisible = false
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    getStatusColor (status) {
      let statusColor = {}
      switch (status) {
        case 'Available':
          statusColor = { 'color': '#327ace' }
          break
        case 'Assigned':
          statusColor = { 'color': '#3fa981' }
          break
      }
      return statusColor
    },
    modifyEnvironment (data) {
      this.currentRowData = data
      this.isApplication = true
      this.resDialogVisible = false
    },
    modifyResource (data) {
      this.currentRowData = data
      this.labDialogVisible = false
      this.resDialogVisible = true
    },
    deleteLab (data) {
      this.$confirm(this.$t('confirm.confirmToDeleteLab'), this.$t('common.warning'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      }).then(() => {
        this.deleteLabConfirm(data)
      })
    },
    deleteLabConfirm (data) {
      let url = BASE_URL + '/deleteLab?id=' + data.id
      axios({
        method: 'DELETE',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.deleteLabConfim'))
        this.getLabs()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    deleteEnvironment (data) {
      let msg = this.$t('confirm.confirmToDeleteEnv')
      if (data.status === 'Assigned') {
        msg = this.$t('confirm.confirmToDeleteEnvAssinged')
      }
      this.$confirm(msg, this.$t('common.warning'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      }).then(() => {
        this.deleteEnvironmentConfirm(data)
      })
    },
    deleteEnvironmentConfirm (data) {
      let url = BASE_URL + '/deleteEnv?id=' + data.id
      axios({
        method: 'DELETE',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.deleteEnvSuccess'))
        this.getEnvDataList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.cancel()
        }
      })
    },
    deleteResource (data) {
      if (data.status === 'Assigned') {
        this.$parent.errorMessage(this.$t('RESOURCE_ALREADY_ASSIGNED'))
        return
      }
      this.$confirm(this.$t('confirm.confirmToDeleteRes'), this.$t('common.warning'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      }).then(() => {
        this.deleteResourceConfirm(data)
      })
    },
    deleteResourceConfirm (data) {
      let url = BASE_URL + '/deleteResource?id=' + data.id
      axios({
        method: 'DELETE',
        url: url,
        data: { 'id': data.id },
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.deleteResSuccess'))
        this.getResDataList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    changeTabs (evt) {
      this.isLab = false
      this.isResources = false
      if (evt.name === 'Resources') {
        this.isResources = true
        this.getResDataList()
        this.getLabs()
        this.selectedTab = 'Resources'
      } else if (evt.name === 'Lab') {
        this.isLab = true
        this.getLabs()
        this.selectedTab = 'Lab'
      } else {
        this.getEnvDataList()
        this.selectedTab = 'Environments'
      }
    },
    handleSelectionChange () {

    },
    async confirmEnvModifcation () {
      let url = BASE_URL + '/modifyEnv'
      this.currentRowData['userId'] = sessionStorage.getItem('userId')
      axios({
        method: 'PUT',
        url: url,
        data: this.currentRowData,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.getEnvDataList()
        this.cancel()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.cancel()
        }
      })
    },
    async confirmResModifcation () {
      let url = BASE_URL + '/modifyResource'
      let type = 'PUT'
      if (this.addResource) {
        url = BASE_URL + '/addResource'
        type = 'POST'
      }
      this.currentRowData['userId'] = sessionStorage.getItem('userId')
      axios({
        method: type,
        url: url,
        data: this.currentRowData,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.cancel()
        this.getResDataList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.cancel()
        }
      })
    },
    async getEnvDataList (data) {
      if (!data) {
        data = {
          name: '',
          status: 'ALL',
          lab: 'ALL'
        }
      }
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getEnv?userId=${userId}&name=${data.name}&lab=${data.lab}&status=${data.status}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationEnvData = res.data.envData
        this.envGraphData = [
          { value: res.data.availableCount, name: 'Available' },
          { value: res.data.assignedCount, name: 'Assigned' }
        ]
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    async getResDataList (data) {
      if (!data) {
        data = {
          ipAddress: '',
          status: 'ALL',
          lab: 'ALL',
          requestedBy: ''
        }
      }
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getResource?userId=${userId}&ipAddress=${data.ipAddress}&lab=${data.lab}&status=${data.status}&requestedBy=${data.requestedBy}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationResData = res.data.resourceData
        this.resGraphData = [
          { value: res.data.availableCount, name: 'Available' },
          { value: res.data.assignedCount, name: 'Assigned' }
        ]
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    cancel (isRefresh) {
      this.addResource = false
      this.labDialogVisible = false
      this.resDialogVisible = false
      this.currentRowData = {}
      this.isApplication = false
      if (isRefresh) {
        this.getEnvDataList()
      }
      this.getResDataList()
    },
    async confirm () {
      this.cancel()
    },
    async getLabs (data) {
      this.labOptions = []
      let url = BASE_URL + '/getLab'
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationLabData = res.data
        for (var i = 0; i < res.data.length; i++) {
          this.labOptions.push(res.data[i].labName)
        }
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    addFile (e) {
      this.labData.append('file', e.target.files[0])
    },
    async addLab () {
      this.currentRowData['userId'] = sessionStorage.getItem('userId')
      this.labData.append('labName', this.currentRowData.labName)
      this.labData.append('owner', this.currentRowData.owner)
      this.labData.append('contact', this.currentRowData.contact)
      this.labData.append('description', this.currentRowData.description)
      this.labData.append('address', this.currentRowData.address)
      this.labData.append('city', this.currentRowData.city)
      this.labData.append('pinCode', this.currentRowData.pinCode)
      this.labData.append('userId', this.currentRowData.userId)
      let url = BASE_URL + '/addLab'
      axios({
        method: 'POST',
        data: this.labData,
        url: url,
        headers: {
          'Content-Type': 'multipart/form-data'
        }
      }).then(res => {
        this.currentRowData = {}
        this.labData = new FormData()
        this.$parent.successMessage(this.$t('confirm.labAddSuccess'))
        this.cancel()
        this.getLabs()
      }, error => {
        if (error) {
          this.labData = new FormData()
          this.$parent.errorMessage(this.$t(error.response.data))
          this.currentRowData = {}
        }
      })
    }
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 2% 1% 2%;
  font-weight: bold;
}
.userList {
    margin: 0 2%;
    height: 100%;
    background: #fff;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
</style>
